=== modified file 'src/com/goldencode/p2j/uast/SymbolResolver.java'
--- old/src/com/goldencode/p2j/uast/SymbolResolver.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/SymbolResolver.java	2022-05-23 20:07:33 +0000
@@ -1,5 +1,5 @@
 /*
-** Module   : SymbolResolver.java
+** Module   : SymbolRame, false);esolver.java
 ** Abstract : manages the symbol dictionaries and lookup process
 **
 ** Copyright (c) 2004-2022, Golden Code Development Corporation.
@@ -474,6 +474,12 @@
 **     CA  20220516          Fixed tracking of extent data members (variables or properties).
 **                           Indexed extent property setters have the index as int64 (and this is forced for
 **                           explicit indexed setters, too).
+**     GES 20220502          Added lookupTableInfo() to reduce the number of name node lookups. Reworked
+**                           translateType() to properly handle buffers, tables, datasets, table-handles,
+**                           dataset-handles and objects. Reworked method name processing and how we track
+**                           methods so that converted method name conflicts are resolved within the class
+**                           hierarchy. This minimizes the number of conflicts since previously the 
+**                           disambiguation was done at a project level.
 */
 
 /*
@@ -742,7 +748,7 @@
       };
       
       @Override
-      public void addVariable(String name, Variable var, Aast node, int access, boolean isStatic, 
+      public void addVariable(int type, String name, Variable var, Aast node, int access, boolean isStatic, 
                               String qname, boolean provisional)
       {
          // no-op
@@ -1295,8 +1301,23 @@
     */
    public static ParameterKey[] calculateDefinitionSignature(Aast def)
    {
-      ParameterKey[] signature = new ParameterKey[0];
-      
+      List<ParameterKey> parms = new LinkedList<ParameterKey>();
+      
+      processDefinitionSignature(def, (Aast ast, ParameterKey key, int idx) -> parms.add(key));
+      
+      return parms.toArray(new ParameterKey[0]);
+   }
+
+   /**
+    * Process a method definition signature (left to right) executing the given consumer for each parameter.
+    * 
+    * @param    def
+    *           The METHOD_DEF node whose signature is processed.
+    * @param    handler
+    *           The consumer of each parameter.
+    */
+   public static void processDefinitionSignature(Aast def, ParameterConsumer handler)
+   {
       if (def != null)
       {
          Aast methkw  = null;
@@ -1317,7 +1338,7 @@
             if (def.getType() != KW_METHOD && def.getType() != KW_CONSTRUC)
             {
                System.out.printf("BAD METHOD NODE %s\n", def.dumpTree());
-               return null;
+               return;
             }
          }
          
@@ -1327,8 +1348,6 @@
          
          if (lparens != null && lparens.getFirstChild() != null)
          {
-            signature = new ParameterKey[lparens.getNumImmediateChildren()];
-            
             // iterate all parameters and extract their types
             Aast parm = (Aast) lparens.getFirstChild();
             
@@ -1336,14 +1355,7 @@
             {
                if (parm.getType() == PARAMETER)
                {
-                  String name = translateType((int) ((long) parm.getAnnotation("type")), parm);
-                  
-                  if ("object".equals(name) || "jobject".equals(name))
-                  {
-                     String qual = (String) parm.getAnnotation("qualified");
-                     
-                     name = String.format("%s<? extends %s>", name, qual);
-                  }
+                  String name = translateType((int) ((long) parm.getAnnotation("type")), parm, null);
                   
                   name = formatExtentName(name, readExtent(parm));
                   
@@ -1359,15 +1371,15 @@
                   }
                   
                   // at definition time, the default mode (if missing) is INPUT
-                  signature[k++] = new ParameterKey(ptype == null ? KW_INPUT : ptype.intValue(), name);
+                  handler.accept(parm,
+                                 new ParameterKey(ptype == null ? KW_INPUT : ptype.intValue(), name),
+                                 k);
                }
                parm = (Aast) parm.getNextSibling();
             }
          }
       }
-      
-      return signature;
-   }
+   }   
    
    /**
     * Read the extent value for the given node if it is specified as an annotation or if there
@@ -1422,7 +1434,7 @@
       else
       {
          Aast child = node.getImmediateChild(KW_EXTENT, null);
-         
+
          if (child != null)
          {
             // there is an extent, default to indeterminate
@@ -1474,54 +1486,7 @@
    }
    
    /**
-    * Get the Java method name for a legacy signature.
-    * 
-    * @param    name
-    *           The legacy name.
-    * @param    sig
-    *           The definition signature.
-    *           
-    * @return   The converted Java name or <code>null</code> if none was computed yet.
-    */
-   public static String getConvertedMethodName(String name, ParameterKey[] sig)
-   {
-      String javaSig = calculateJavaSignature(name, sig);
-      
-      WorkArea wa = locate();
-      Map<String, String> methods = wa.javaMethodCollisions.get(javaSig);
-      if (methods == null)
-      {
-         return null;
-      }
-      
-      String legacySig = calculateLegacySignature(name, sig);
-      return methods.get(legacySig);
-   }
-   
-   /**
-    * Get the Java method name for a legacy signature.
-    * 
-    * @param    legacySig
-    *           The legacy signature.
-    * @param    javaSig
-    *           The converted Java signature.
-    *           
-    * @return   The converted Java name or <code>null</code> if none was computed yet.
-    */
-   public static String getConvertedMethodName(String legacySig, String javaSig)
-   {
-      WorkArea wa = locate();
-      Map<String, String> methods = wa.javaMethodCollisions.get(javaSig);
-      if (methods == null)
-      {
-         return null;
-      }
-      
-      return methods.get(legacySig);
-   }
-   
-   /**
-    * Compute the Java signature for a legacy method - this will include the legacy name and the
+    * Compute the Java signature for a legacy method - this will include the converted method name and the
     * parameter representation in the converted Java code, but not the return type.
     * 
     * @param    name
@@ -1536,25 +1501,63 @@
       WorkArea wa = local.get();
       
       String jname = wa.nconvert.convert(name, MatchPhraseConstants.TYPE_METHOD);
+      
       // in 4GL, the method names are case-insensitive - even if we want a Java signature here,
-      // we still need to use a lowercased name, as otherwise overriden methods may not be resolved
+      // we still need to use a lowercased name, as otherwise overridden methods may not be resolved
       // properly (as 4GL has no restriction for an overridden method to have the same case as
       // the parent method).
       jname = jname.toLowerCase();
-      String s = jname + "(";
+      
+      return jname.toLowerCase() + "(" + calculateJavaParameters(sig) + ")";
+   }
+   
+   /**
+    * Compute the Java signature for the legacy method parameters (does not include the parenthesis).
+    * 
+    * @param    sig
+    *           The parameter definition.
+    *           
+    * @return   The Java representation of the parameter list or "" if there are no parameters.
+    */
+   public static String calculateJavaParameters(ParameterKey[] sig)
+   {
+      String core = "";
+      
       if (sig != null)
       {
-         for (ParameterKey pk : sig)
+         for (int i = 0; i < sig.length; i++)
          {
-            s = s + (s.endsWith("(") ? "" : ", ") + pk.toJava();
+            core = core + (i == 0 ? "" : ", ") + sig[i].toJava();
          }
       }
-      return s + ")";
-   }
-   
-   /**
-    * Compute the legacy signature for a legacy method - this will include the legacy name and the
-    * parameter representation, but not the return type.
+      
+      return core;
+   }
+   
+   /**
+    * Given a Java method with a {@link LegacySignature}, reverse-compute its 4GL signature.
+    * 
+    * @param    mname
+    *           The legacy method name.
+    * @param    lsig
+    *           The legacy signature annotation.
+    */
+   public static String calculateLegacySignature(String mname, LegacySignature lsig)
+   {
+      LegacyParameter[] lparms = lsig.parameters();
+      ParameterKey[]    sig    = new ParameterKey[(lparms == null) ? 0 : lparms.length];
+      
+      for (int i = 0; i < lparms.length; i++)
+      {
+         sig[i] = new ParameterKey(lparms[i]);
+      }
+      
+      return calculateLegacySignature(mname, sig);
+   }
+   
+   /**
+    * Compute the legacy signature for a legacy method - this will include the legacy name (lowercased) and
+    * the parameter list, but not the return type.
     * 
     * @param    name
     *           The legacy name.
@@ -1565,8 +1568,8 @@
     */
    public static String calculateLegacySignature(String name, ParameterKey[] sig)
    {
-      String jname = name.toLowerCase();
-      String s = jname + "(";
+      String s = name.toLowerCase() + "(";
+      
       if (sig != null)
       {
          for (ParameterKey pk : sig)
@@ -1574,6 +1577,7 @@
             s = s + (s.endsWith("(") ? "" : ", ") + pk.toString();
          }
       }
+      
       return s + ")";
    }
 
@@ -1585,161 +1589,149 @@
     * when they are defined in an already converted class.
     * 
     * @param    stype
-    *           The member type.
+    *           Token type of the defining statement.
+    * @param    cls
+    *           The class in which the property or event exists.
+    * @param    node
+    *           The AST node being processed.
     * @param    var
     *           The associated variable for this member.
     * @param    name
     *           The legacy name.
     */
-   public static void trackMethodSignatures(int stype, Variable var, String name)
+   public static void trackPropertyOrEventMethodSignatures(int             stype,
+                                                           ClassDefinition cls,
+                                                           Aast            node,
+                                                           Variable        var,
+                                                           String          name)
    {
       if (isPreScan())
       {
          return;
       }
       
+      boolean over = var.isOverride();
+      boolean abst = var.isAbstract();
+      
       if (stype == DEFINE_PROPERTY)
       {
-         String ptype = translateType(var.getTokenType(), null);
-         if ("object".equals(ptype) && var.getClassName() != null)
-         {
-            ptype = "object<? extends " + var.getClassName() + ">";
-         }
+         String ptype = translateType(var.getTokenType(), null, var.getClassName());
+         
+         
          if (var.isExtent())
          {
-            String ext = var.isExtent() 
-                           ? "[" + (var.getExtent() > 0 ? Integer.toString(var.getExtent()) : "") +"]" 
-                           : "";
-
-            trackMethodSignature(null, "get-" + name, new ParameterKey[0]);
-            trackMethodSignature(null,
-                                 "get-" + name, 
-                                 new ParameterKey[]
-                                 {
-                                    new ParameterKey(KW_INPUT, "int64")
-                                 });
-            trackMethodSignature(null,
-                                 "set-" + name, 
-                                 new ParameterKey[]
-                                 {
-                                    new ParameterKey(KW_INPUT, ptype + ext)
-                                 });
-            trackMethodSignature(null,
-                                 "set-" + name, 
-                                 new ParameterKey[]
-                                 {
-                                    new ParameterKey(KW_INPUT, ptype),
-                                    new ParameterKey(KW_INPUT, "int64")
-                                 });
-            trackMethodSignature(null, "length-of-" + name, new ParameterKey[0]);
-            trackMethodSignature(null,
-                                 "resize-" + name, 
-                                 new ParameterKey[]
-                                 {
-                                    new ParameterKey(KW_INPUT, "int64")
-                                 });
+            String ext = "[" + (var.getExtent() > 0 ? Integer.toString(var.getExtent()) : "") +"]";
+
+            cls.registerPropertyMethod(node, "bulk-get", name, over, abst, new ParameterKey[0]);
+            cls.registerPropertyMethod(node,
+                                       "get",
+                                       name,
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, "int64")
+                                       });
+            
+            cls.registerPropertyMethod(node,
+                                       "bulk-set",
+                                       name, 
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, ptype + ext)
+                                       });
+            cls.registerPropertyMethod(node,
+                                       "set",
+                                       name,
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, ptype),
+                                          new ParameterKey(KW_INPUT, "int64")
+                                       });
+
+            cls.registerPropertyMethod(node,
+                                       "set-all",
+                                       name,
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, ptype)
+                                       });
+            
+            cls.registerPropertyMethod(node, "length-of", name, over, abst, new ParameterKey[0]);
+            cls.registerPropertyMethod(node,
+                                       "resize",
+                                       name,
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, "int64")
+                                       });
          }
          else
          {
-            trackMethodSignature(null, "get-" + name, new ParameterKey[0]);
-            trackMethodSignature(null,
-                                 "set-" + name, 
-                                 new ParameterKey[]
-                                 {
-                                    new ParameterKey(KW_INPUT, ptype)
-                                 });
+            cls.registerPropertyMethod(node, "get", name, over, abst, new ParameterKey[0]);
+            cls.registerPropertyMethod(node,
+                                       "set",
+                                       name,
+                                       over,
+                                       abst,
+                                       new ParameterKey[]
+                                       {
+                                          new ParameterKey(KW_INPUT, ptype)
+                                       });
          }
       }
       else if (stype == DEFINE_EVENT)
       {
-         trackMethodSignature(null, "subscribe-" + name, 
-                              new ParameterKey[]
-                              {
-                                 new ParameterKey(KW_INPUT, "handle"),
-                                 new ParameterKey(KW_INPUT, "character"),
-                              });
-         trackMethodSignature(null, "unsubscribe-" + name, 
-                              new ParameterKey[]
-                              {
-                                 new ParameterKey(KW_INPUT, "handle"),
-                                 new ParameterKey(KW_INPUT, "character"),
-                              });
-         trackMethodSignature(null, "subscribe-" + name, 
-                              new ParameterKey[]
-                              {
-                                 new ParameterKey(KW_INPUT, "object<? extends progress.lang.object>"),
-                                 new ParameterKey(KW_INPUT, "character"),
-                              });
-         trackMethodSignature(null, "unsubscribe-" + name, 
-                              new ParameterKey[]
-                              {
-                                 new ParameterKey(KW_INPUT, "object<? extends progress.lang.object>"),
-                                 new ParameterKey(KW_INPUT, "character"),
-                              });
+         cls.registerPropertyMethod(node, "subscribe", name, over, abst, 
+                                    new ParameterKey[]
+                                    {
+                                       new ParameterKey(KW_INPUT, "handle"),
+                                       new ParameterKey(KW_INPUT, "character"),
+                                    });
+         cls.registerPropertyMethod(node, "unsubscribe", name, over, abst,
+                                    new ParameterKey[]
+                                    {
+                                       new ParameterKey(KW_INPUT, "handle"),
+                                       new ParameterKey(KW_INPUT, "character"),
+                                    });
+         cls.registerPropertyMethod(node, "subscribe", name, over, abst,
+                                    new ParameterKey[]
+                                    {
+                                       new ParameterKey(KW_INPUT, "object<? extends progress.lang.object>"),
+                                       new ParameterKey(KW_INPUT, "character"),
+                                    });
+         cls.registerPropertyMethod(node, "unsubscribe", name, over, abst,
+                                    new ParameterKey[]
+                                    {
+                                       new ParameterKey(KW_INPUT, "object<? extends progress.lang.object>"),
+                                       new ParameterKey(KW_INPUT, "character"),
+                                    });
          
          // TODO: publish-[evtName] isn't tracked - not sure if even is required to do so
-         // trackMethodSignature(null, "publish-" + name, pkey);
+         // cls.registerPropertyMethod(node, "publish-", name, over, abst, pkey);
       }
    }
    
    /**
-    * Track this method signature so that an overloaded suffix can be computed, to avoid collisions
-    * in the generated Java code.
+    * Convert the given legacy method name to Java and return it.
     * 
-    * @param    javaname
-    *           The javaname to forcibly assign to this legacy signature, or <code>null</code> to
-    *           compute an unique one.
     * @param    name
-    *           The legacy name.
-    * @param    sig
-    *           The parameter definition.
+    *           The the 4GL method name.
+    *           
+    * @return   The converted Java method name.
     */
-   public static void trackMethodSignature(String javaname, String name, ParameterKey[] sig)
+   public static String convertMethodName(String name)
    {
       WorkArea wa = locate();
-      // can't track the static mode at the signature, as at the time we resolve the name, we don't
-      // know if this is for a static or for a instance call.
-      String javaSig = calculateJavaSignature(name, sig);
-      String legacySig = calculateLegacySignature(name, sig);
-      
-      Map<String, String> methods = wa.javaMethodCollisions.get(javaSig);
-      if (methods == null)
-      {
-         wa.javaMethodCollisions.put(javaSig, methods = new LinkedHashMap<>());
-      }
-      if (javaname != null)
-      {
-         // force this method name...
-         methods.put(legacySig, javaname);
-      }
-      else
-      {
-         methods.putIfAbsent(legacySig, javaname);
-      }
-
-      if (methods.get(legacySig) == null)
-      {
-         String jname = wa.nconvert.convert(name, MatchPhraseConstants.TYPE_METHOD);
-         if (methods.size() == 1)
-         {
-            methods.put(legacySig, jname);
-            return;
-         }
-
-         // TODO: the suffix can be replaced with something more verbose, to indicate i.e. the
-         // collision reason
-         int suffix = 1;
-         while (true)
-         {
-            String candidate = jname + "_" + suffix;
-            if (!methods.values().contains(candidate))
-            {
-               methods.put(legacySig, candidate);
-               break;
-            }
-            suffix = suffix + 1;
-         }
-      }
+      return wa.nconvert.convert(name, MatchPhraseConstants.TYPE_METHOD);
    }
    
    /**
@@ -1749,10 +1741,12 @@
     *           The token type representing a variable/parameter type. 
     * @param    parm
     *           The PARAMETER node which is used to extract the type of this parameter.
+    * @param    qualified
+    *           Fully qualified object classname or {@code null} if no qualifier is needed. 
     *
     * @return   The wrapper class name.
     */
-   public static String translateType(int type, Aast parm)
+   public static String translateType(int type, Aast parm, String qualified)
    {
       if (parm != null)
       {
@@ -1764,10 +1758,6 @@
          {
             return "TABLE-HANDLE";
          }
-         else if (parm.downPath("KW_TABLE") || parm.getType() == KW_TABLE)
-         {
-            return "TEMP-TABLE";
-         }
       }
 
       String cls = null;
@@ -1825,22 +1815,49 @@
             break;
          case VAR_CLASS:
             cls = "object";
+            
+            String qual = qualified;
+            
             if (parm != null)
             {
                if (parm.isAnnotation("is-java") && (Boolean) parm.getAnnotation("is-java"))
                {
                   cls = "jobject";
                }
+               
+               if (qualified == null)
+               {
+                  qual = (String) parm.getAnnotation("qualified");
+               }
             }
+            
+            cls = String.format("%s<? extends %s>", cls, qual);
             break;
             
-         // TABLE and BUFFER parameters - these will have the TABLE or BUFFER prefix,
-         // followed by the schemaname.
+         // TABLE and BUFFER parameters - these will have the TEMP-TABLE or BUFFER prefix,
+         // followed by the schemaname or other details that make the table unambigous
          case KW_TABLE:
             ref = parm.getType() == KW_TABLE ? parm : parm.getImmediateChild(KW_TABLE, null);
             ref = ref.getImmediateChild(TEMP_TABLE, null);
+            
+            if (ref == null)
+            {
+               // this is unexpected since permanent tables and work-tables should not be possible here
+               // and buffers are handled below
+               throw new RuntimeException(String.format("TABLE parameters should be temp-tables: %s",
+                                                        parm.dumpTree()));
+            }
+            
+            String signature = (String) ref.getAnnotation("db_signature");
+            
+            if (signature == null)
+            {
+               throw new RuntimeException(String.format("Missing 'db_signature' annotation in: %s",
+                                                        ref.dumpTree()));
+            }
+            
             // for temp-tables, the compile time mapping is done via the table's field signature
-            cls = "TEMP-TABLE";
+            cls = String.format("TEMP-TABLE <%s>", signature);
             break;
          case KW_BUFFER:
             ref = parm.getType() == KW_BUFFER ? parm : parm.getImmediateChild(KW_BUFFER, null);
@@ -1852,18 +1869,51 @@
             if (ref.getType() == TEMP_TABLE || 
                 (ref.getType() == BUFFER && "".equals(ref.getAnnotation("dbname"))))
             {
-               cls = "BUFFER <temp-table>";
+               String tabname = (String) ref.getAnnotation("schemaname");
+               String tabsig  = (String) ref.getAnnotation("db_signature");
+               
+               if (tabsig == null)
+               {
+                  throw new RuntimeException(String.format("Missing 'db_signature' annotation in: %s",
+                                                           ref.dumpTree()));
+               }
+               
+               cls = String.format("BUFFER <temp-table %s <%s>>", tabname.toLowerCase(), tabsig);
             }
             else
             {
-               cls = String.format("BUFFER %s", ref.getAnnotation("schemaname"));
+               cls = String.format("BUFFER <%s>", ref.getAnnotation("schemaname"));
             }
             break;
          case KW_DATASET:
-            cls = "DATASET";
+            ref = parm.getType() == KW_DATASET ? parm : parm.getImmediateChild(KW_DATASET, null);
+            
+            if (ref == null)
+            {
+               throw new RuntimeException(String.format("Missing KW_DATASET in: %s", parm.dumpTree()));
+            }
+            
+            ref = (Aast) ref.getFirstChild();
+            
+            if (ref == null || ref.getType() != DATA_SET)
+            {
+               throw new RuntimeException(String.format("Missing DATA_SET in: %s", parm.dumpTree()));
+            }
+            
+            String sig = (String) ref.getAnnotation("db_signature");
+            
+            if (sig == null)
+            {
+               throw new RuntimeException(String.format("Missing 'db_signature' annotation in: %s",
+                                                        ref.dumpTree()));
+            }
+            
+            cls = String.format("DATASET %s", sig);
             break;
          case KW_DATA_SRC:
-            // TODO: example with this as parameter and argument?
+            // TODO: as far as I know, this is not possible; dump some data so we can generate an example 
+            //       with this as parameter and argument
+            System.err.printf("WARNING: UNEXPECTED DATA-SOURCE PARAMETER %s\n", parm.dumpTree());
             cls = "DATA-SOURCE";
             break;
       }
@@ -1919,10 +1969,11 @@
                 type != KW_BY_VALUE)
             {
                String cls = ExpressionConversionWorker.expressionType(parm, false, false);
-               
-               if ("Buffer".equalsIgnoreCase(cls))
+
+               // this is not just buffers, it is also any form of table reference except for table-handle
+               if ("Buffer".equalsIgnoreCase(cls) || "DATASET".equalsIgnoreCase(cls))
                {
-                  cls = translateType(parm.getType(), parm);
+                  cls = translateType(parm.getType(), parm, null);
                }
                else
                {
@@ -2012,7 +2063,7 @@
    }
 
    /**
-    * Load the specified converted class.  This lookup an instance from an already-converted class.
+    * Load the specified class definition.
     * 
     * @param    qname
     *           The legacy OO class qualified name.
@@ -2022,7 +2073,7 @@
     * @throws   ClassNotFoundException
     *           If the class can't be resolved or loaded.
     */
-   public static ConvertedClassName loadConvertedClassByQname(String qname)
+   public static ClassDefinition loadConvertedClassByQname(String qname)
    throws ClassNotFoundException
    {
       String fname = ConversionData.findClassFilename(qname);
@@ -2036,7 +2087,7 @@
    }
    
    /**
-    * Load the specified converted class.  This will either create a {@link ClassDefinition}
+    * Load the specified class definition.  This will either create a {@link ClassDefinition}
     * structure for a new class (to be later populated with members by the parser), or will restore
     * an instance from an already-converted class.
     * 
@@ -2046,12 +2097,12 @@
     *           Flag indicating that this is a new class (now being parsed), or a previously
     *           converted class.
     *           
-    * @return   See above.
+    * @return   The class definition.
     * 
     * @throws   ClassNotFoundException
     *           If the class can't be resolved or loaded.
     */
-   public static ConvertedClassName loadConvertedClass(String filename, boolean isNew)
+   public static ClassDefinition loadConvertedClass(String filename, boolean isNew)
    throws ClassNotFoundException
    {
       WorkArea wa = local.get();
@@ -2068,38 +2119,23 @@
          wa.fname2qname.put(filename, qname);
       }
       
-      ConvertedClassName cclass = wa.cvtCache.get(qname);
-      if (cclass != null)
-      {
-         return cclass;
-      }
-      
+      ClassDefinition clsdef = null;
+            
       if (isNew)
       {
-         ClassDefinition clsDef = getClassDefinition(qname);
-         if (clsDef != null)
-         {
-            Object[] clsDetails = ConversionData.getConvertedClassName(filename);
-            cclass = new ConvertedClassName(clsDef, 
-                                            (String) clsDetails[0], 
-                                            (String) clsDetails[1]);
-            wa.cvtCache.put(qname, cclass);
-            
-            return cclass;
-         }
-         else
+         clsdef = getClassDefinition(qname);
+         
+         if (clsdef == null)
          {
             throw new ClassNotFoundException("Can not find class " + qname + " from " + filename);
          }
       }
-      
-      ClassDefinition clsDef = loadClassDefinition(qname);
-      cclass = new ConvertedClassName(clsDef, clsDef.getJavaPackage(), clsDef.getJavaSimpleName());
-      clsDef.initialize(cclass);
-      
-      wa.cvtCache.put(qname, cclass);
-      
-      return cclass;
+      else
+      {
+         clsdef = loadClassDefinition(qname);
+      }
+      
+      return clsdef;
    }
    
    /**
